<template>
  <q-page class="q-px-md q-mt-md">
    <q-btn
      @click="handleClickBack()"
      class="text-center"
      color="red"
      icon="arrow_back_ios"
      >กลับ</q-btn
    >
    <q-card>
      <q-card-section>
        <div class="row q-gutter-x-sm">
          <div
            class="col-auto text-right"
            style="line-height: 40px; min-width: 80px;"
          >
            ประเภทเกม
          </div>
          <div class="col">
            <q-checkbox
              v-model="game_type"
              :key="item.code"
              v-for="item in groupList"
              :val="item.code"
              :label="item.code"
            />
          </div>
        </div>
      </q-card-section>
      <q-card-section>
        <div class="row q-gutter-x-sm">
          <div
            class="col-auto text-right"
            style="line-height: 50px; min-width: 80px;"
          >
            ผู้ให้บริการ
          </div>
          <div class="col-10 col-md-auto">
            <q-select
              outlined
              dense
              v-model="provider_code"
              multiple
              :options="providerList"
              option-value="code"
              option-label="name"
              emit-value
              style="min-width: 250px; "
            >
              <template v-if="provider_code.length > 0" v-slot:append>
                <q-icon
                  name="cancel"
                  @click.stop="provider_code = []"
                  class="cursor-pointer"
                />
              </template>
            </q-select>
          </div>
        </div>
      </q-card-section>
      <q-card-section>
        <StartDateEndDateFilterComponent :filter="dateFilter" />
      </q-card-section>
      <q-card-section>
        <q-btn color="green" @click.prevent="onSearch" icon="search"
          >ค้นหา</q-btn
        >
      </q-card-section>
      <q-table
        :rows-per-page-options="[15, 25, 50]"
        :pagination.sync="pagination"
        :loading="loading"
        :data="data"
        separator="cell"
        row-key="id"
        @request="onRequest"
      >
        <template slot="header" slot-scope="props" :props="props">
          <q-tr>
            <q-th rowspan="2" class="bg-blue-9 text-white">รายการ</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">
              ยูสเซอร์เนม
            </q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">เลขอ้างอิง</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">เวลาคิดผล</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">ประเภท</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">ผู้ให้บริการ</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">Bet</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">ครั้ง</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">ถือสู้</q-th>
            <q-th colspan="1" class="bg-blue-10 text-white">สมาชิก</q-th>
            <q-th colspan="1" class="bg-blue-10 text-white">เอเย่น</q-th>
            <q-th v-if="role < 5" colspan="1" class="bg-blue-10 text-white"
              >ซีเนียร์</q-th
            >
            <q-th v-if="role < 4" colspan="1" class="bg-blue-10 text-white"
              >ผู้ถือหุ้น</q-th
            >
            <q-th colspan="1" class="bg-blue-10 text-white">คอมปะนี</q-th>
            <q-th v-if="role <= 2" colspan="1" class="bg-blue-10 text-white"
              >Smart Bet</q-th
            >
            <q-th v-if="role < 2" colspan="1" class="bg-blue-10 text-white"
              >Provider</q-th
            >
          </q-tr>
          <q-tr>
            <q-th
              class="bg-light-blue-5 text-white"
              v-for="index in role < 2 ? 7 : 6 - role + 2"
              :key="index"
              >W/L
            </q-th>
          </q-tr>
        </template>
        <template slot="body" slot-scope="props" :props="props">
          <MemberRow
            :provider="providerList"
            :row="props.row"
            :key="props.row.transaction"
          />
        </template>
        <template slot="bottom" slot-scope="props" :props="props">
          <div class="col">
            <div class="row reverse q-gutter-x-md">
              <div class="col-md-auto">
                <q-btn
                  color="secondary"
                  v-if="
                    props.pagination.rowsPerPage * props.pagination.page <=
                      props.pagination.rowsNumber
                  "
                  size="sm"
                  label="หน้าถัดไป"
                  @click.prevent="props.nextPage()"
                  icon-right="chevron_right"
                />
              </div>
              <div class="col-md-auto">
                <q-btn
                  color="info"
                  v-if="props.pagination.page > 1"
                  size="sm"
                  label="หน้าแรก"
                  @click.prevent="props.firstPage()"
                  icon="first_page"
                />
              </div>
            </div>
          </div>
        </template>
        <template v-slot:loading>
          <q-inner-loading showing color="primary" />
        </template>
      </q-table>
    </q-card>
  </q-page>
</template>
<script>
import { mapState, mapGetters, mapActions } from "vuex";
import { load_member_transaction } from "src/store/report/v2/actions";
import MemberRow from "./member_member_tr";

import { SessionStorage } from "quasar";
import StartDateEndDateFilterComponent from "components/StartDateEndDateFilterComponent";

export default {
  name: "Report-Member-Member",
  components: { MemberRow, StartDateEndDateFilterComponent },
  data() {
    return {
      data: [],
      dateFilter: {
        startDate: new Date(),
        startTime: new Date(new Date().setHours(0, 0, 0, 0)),
        endDate: new Date(),
        endTime: new Date(new Date().setHours(23, 59, 59, 999))
      },
      game_type: [],
      provider_code: [],
      loading: false,
      filter: {
        parent_id: this.$route.params.id
      },
      pagination: {
        sortBy: "desc",
        descending: false,
        page: 1,
        rowsPerPage: 15,
        rowsNumber: 0
      },
      groupList: [],
      providerList: []
    };
  },
  beforeRouteEnter(to, from, next) {
    if (to.params.username) {
      to.meta.breadcrumbs[to.meta.breadcrumbs.length - 1].title =
        to.params.username;
      document.title = `${to.params.username} - Report Member`;
    }
    next();
  },
  async created() {
    if (SessionStorage.getItem(`group_list_filter`)) {
      this.groupList = SessionStorage.getItem(`group_list_filter`);
    } else {
      try {
        const {
          data: { results }
        } = await this.load_list();
        if (results) {
          this.groupList = results.filter(
            (item, index) =>
              results.findIndex(r => r.code == item.code) == index
          );
          SessionStorage.set("group_list_filter", this.groupList);
        }
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
    }
    if (SessionStorage.getItem(`provider_list_filter`)) {
      this.providerList = SessionStorage.getItem(`provider_list_filter`);
    } else {
      try {
        const { data } = await this.load_provider();
        if (data) {
          this.providerList = data
            .filter(
              (item, index) => data.findIndex(r => r.code == item.code) == index
            )
            .map(x => {
              return {
                code: x.code,
                name: x.name
              };
            });
          SessionStorage.set("provider_list_filter", this.providerList);
        }
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
    }
    if (Object.keys(this.$route.query).length > 0) {
      const {
        datetime_start,
        datetime_end,
        game_type,
        provider_code
      } = this.$route.query;
      if (datetime_start) {
        this.dateFilter.startDate = dayjs(
          datetime_start.replace(/Z/g, ""),
          "YYYY-MM-DDTHH:mm:ss"
        );
        this.dateFilter.startTime = dayjs(
          datetime_start.replace(/Z/g, ""),
          "YYYY-MM-DDTHH:mm:ss"
        );
      }
      if (datetime_end) {
        this.dateFilter.endDate = dayjs(
          datetime_end.replace(/Z/g, ""),
          "YYYY-MM-DDTHH:mm:ss"
        );
        this.dateFilter.endTime = dayjs(
          datetime_end.replace(/Z/g, ""),
          "YYYY-MM-DDTHH:mm:ss"
        );
      }
      if (game_type) {
        this.game_type = game_type.split(",");
      }
      if (provider_code) {
        this.provider_code = provider_code.split(",");
      }
      await this.onRequest({
        pagination: this.pagination,
        filter: this.filter
      });
    } else {
      this.game_type = this.groupList.map(x => x.code);
    }
  },
  computed: {
    ...mapState("auth", ["role"])
  },
  methods: {
    ...mapActions("report/v2", ["load_member_transaction"]),
    ...mapActions("group/v2", ["load_list"]),
    ...mapActions("provider", { load_provider: "load" }),
    getDateTime(date, time) {
      let dateFormat = "YYYY-MM-DD";
      let timeFormat = "HH:mm:ss";
      return (
        dayjs(
          `${dayjs(date).format(dateFormat)} ${dayjs(time).format(timeFormat)}`,
          "YYYY-MM-DD HH:mm:ss"
        )
          .utc()
          .format(`${dateFormat} ${timeFormat}`) + "Z"
      );
      // return `${dayjs(date).format('YYYY-MM-DD')}T${dayjs(time).format('HH:mm:ss')}Z`;
    },
    getFilterParameter({ filter, pagination }) {
      let datetime_start = undefined;
      let datetime_end = undefined;
      if (this.dateFilter.startDate) {
        if (this.dateFilter.startTime) {
          datetime_start = this.getDateTime(
            this.dateFilter.startDate,
            this.dateFilter.startTime
          );
        } else {
          datetime_start = this.getDateTime(
            this.dateFilter.startDate,
            new Date().setHours(0, 0, 0, 0)
          );
        }
      }
      if (this.dateFilter.endDate) {
        if (this.dateFilter.endTime) {
          datetime_end = this.getDateTime(
            this.dateFilter.endDate,
            this.dateFilter.endTime
          );
        } else {
          datetime_end = this.getDateTime(
            this.dateFilter.endDate,
            new Date().setHours(23, 59, 59, 999)
          );
        }
      }
      return {
        game_type: this.game_type.join(","),
        ...filter,
        ...pagination,
        datetime_start,
        datetime_end,
        parent_id: this.$route.params.id,
        provider_code: this.provider_code.join(","),
        ...filter,
        ...pagination
      };
    },
    async onRequest(props) {
      this.loading = true;
      const { page = 1, rowsPerPage, sortBy, descending } = props.pagination;
      let transaction = undefined;
      if (page > 1) {
        if (this.data.length > 0 && page > this.pagination.page) {
          transaction = this.data[this.data.length - 1].transaction;
        }
      }
      const parameters = this.getFilterParameter(props);
      const {
        data: { results, totalCount }
      } = await this.load_member_transaction({
        ...parameters,
        transaction: transaction
      });
      // clear out existing data and add new
      this.data.splice(0, this.data.length, ...results);
      if (!this.firstTotalCount) {
        this.firstTotalCount = totalCount;
      }

      // don't forget to update local pagination object
      this.pagination.page = page;
      this.pagination.rowsPerPage = 10;
      this.pagination.rowsNumber = this.firstTotalCount;
      this.pagination.sortBy = sortBy;
      this.pagination.descending = descending;
      this.loading = false;
    },
    async onSearch() {
      await this.onRequest({
        pagination: this.pagination,
        filter: this.filter
      });
    }
  }
};
</script>
<style lang="scss">
label {
  margin: 8px 0;
}

.el-input__inner,
.q-field--outlined .q-field__control:before {
  border-color: black;
}
</style>
